<template>
  <a-drawer
    title="Basic Drawer"
    width="80%"
    :visible="visible"
    @close="$emit('on-close')"
  >
    <div class="create-plan">
      <p class="title-h1 create-plan--title">
        Création du plan d'animation commercial
      </p>
      <a-form
        class="create-plan--form"
        :colon="false"
        name="normal_login"
        ref="formCreatePlan"
        hideRequiredMark
        :model="plan"
        :rules="rules"
        @finish="onFinish"
        @finishFailed="onFinishFailed"
      >
        <div>
          <div class="create-plan--main">
            <a-form-item name="name" label="Nom du plan*">
              <a-input
                id="plan-name"
                v-model:value="plan.name"
                placeholder="Nom du plan"
              >
              </a-input>
            </a-form-item>
            <a-form-item name="date" label="Dates du plan*">
              <a-range-picker
                :getPopupContainer="(trigger) => trigger.parentNode"
                :format="dateFormat"
                v-model:value="plan.date"
                :placeholder="['Nom du plan', 'Date de fin']"
              />
            </a-form-item>
            <a-form-item name="direction" label="Direction*">
              <a-select
                v-model:value="plan.direction"
                ref="select"
                :options="directionOptions"
              />
            </a-form-item>
            <a-form-item label="Description du plan">
              <a-textarea
                v-model:value="plan.description"
                :auto-size="{ minRows: 4, maxRows: 5 }"
              />
            </a-form-item>
          </div>
          <div class="create-plan--additional">
            <p class="title-large create-plan--subtitle">
              Ajouter des opérations (optionnel) :
            </p>
            <div v-for="(operation, index) in plan.operations" :key="index">
              <a-form-item
                :rules="{
                  required: true,
                  message: 'Veuillez saisir tous les champs obligatoires',
                }"
                :name="['operations', index, 'operationName']"
                label="Nom du plan*"
              >
                <a-input v-model:value="operation.operationName" placeholder="">
                </a-input>
              </a-form-item>
              <a-form-item
                :rules="{
                  required: true,
                  message: 'Veuillez saisir tous les champs obligatoires',
                }"
                :name="['operations', index, 'type']"
                label="Direction*"
              >
                <a-select ref="select" v-model:value="operation.type">
                  <a-select-option value="jack">Jack</a-select-option>
                  <a-select-option value="lucy">Lucy</a-select-option>
                </a-select>
              </a-form-item>
              <a-form-item
                :rules="{
                  required: true,
                  message: 'Veuillez saisir tous les champs obligatoires',
                }"
                :name="['operations', index, 'date']"
                label="Dates du plan*"
              >
                <a-range-picker
                  :format="dateFormat"
                  :disabledDate="disabledDate"
                  v-model:value="operation.date"
                  :getPopupContainer="(trigger) => trigger.parentNode"
                  :placeholder="['Nom du plan', 'Date de fin']"
                />
              </a-form-item>
              <DeleteOutlined
                :style="{
                  fontSize: '20px',
                  color: '#7B7B7B',
                  marginTop: '12px',
                }"
                @click="deleteOperation(index)"
              />
            </div>
          </div>
          <a-button @click="addPlan" class="ant-btn ant-btn-outlined">
            <template #icon><PlusOutlined /></template>
            Ajouter une opération
          </a-button>
        </div>
        <div>
          <hr />
          <div class="create-plan--footer">
            <ul class="create-plan--error-list">
              <li v-for="(error, index) in errors" :key="index">{{ error }}</li>
            </ul>
            <a-button
              html-type="submit"
              type="primary"
              class="ant-btn ant-btn-purple"
            >
              Créer un plan commercial
            </a-button>
          </div>
        </div>
      </a-form>
      <pre>{{ plan.date[1] ? plan.date[1] + 1 : '' }}</pre>
    </div>
  </a-drawer>
</template>
<script setup lang="ts">
import { PlusOutlined, DeleteOutlined } from '@ant-design/icons-vue';
import { reactive, ref, toRefs, watch } from 'vue';
import { errorValidator } from '@/shared/composables/errorValidator';

const props = defineProps({
  visible: {
    type: Boolean,
    default: false,
  },
});
const formCreatePlan = ref();
const allProps = toRefs(props);
const visible = allProps.visible;
watch(visible, (val) => {
  if (val && formCreatePlan.value) {
    errors.value = [];
    formCreatePlan.value.resetFields();
  }
});
const required = {
  required: true,
  message: 'Veuillez saisir tous les champs obligatoires',
};
const dateFormat = 'DD/MM/YYYY';
const rules = {
  name: required,
  date: required,
  direction: required,
  plan: required,
};
type Plan = {
  name: string;
  date: Array<string>;
  direction: number | undefined;
  description: string;
  plan: string;
  operations: Array<Operation>;
};
type Operation = {
  operationName: string;
  type: number | undefined;
  date: Array<string>;
};
const plan: Plan = reactive({
  name: '',
  date: [],
  description: '',
  direction: undefined,
  plan: '',
  operations: [],
});
const errors = ref<Array<string>>([]);
const oneDayInSeconds = 864e5;
const directionOptions = ref([
  {
    value: 0,
    label: 'Jack',
  },
  {
    value: 1,
    label: 'Lucy',
  },
  {
    value: 2,
    label: 'Disabled',
  },
  {
    value: 3,
    label: 'Yiminghe',
  },
]);
let { getErrorMessages, getErrors, filterArray } = errorValidator();
const addPlan = () => {
  plan.operations.push({
    operationName: '',
    date: [],
    type: undefined,
  });
};

const disabledDate = (current: any) => {
  return plan.date
    ? current &&
        (current < plan.date[0] ||
          current.valueOf() - oneDayInSeconds > +plan.date[1])
    : '';
};
const deleteOperation = (index: number) => {
  plan.operations.splice(index, 1);
};
const onFinishFailed = (err: any) => {
  errors.value = getErrors(err.errorFields);
  errors.value = filterArray(errors.value, getErrorMessages([]));
};
const onFinish = () => {
  errors.value = [];
};
</script>
<script lang="ts">
export default {
  name: 'CreatePlanComponent',
};
</script>

<style scoped lang="scss">
@import '@/assets/styles/components/forms';
.create-plan {
  margin: 0 8%;
  .ant-input {
    @include custom-input;
  }
  textarea .ant-input {
    height: auto;
  }
  &--title {
    margin-bottom: 64px;
  }
  &--form {
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    min-height: 80vh;
  }
  &--subtitle {
    margin-bottom: 32px;
  }
  &--main {
    width: 50%;
  }
  &--additional > div,
  &--footer {
    display: flex;
    justify-content: space-between;
  }
  &--error-list {
    list-style-type: none;
    @include validation-error;
    font-size: var(--base);
  }
  &--additional > div {
    align-items: center;
    gap: 24px;
    .delete-icon {
      font-size: 20px;
    }
    .ant-form-item {
      min-width: 30%;
      &:first-child {
        min-width: 35%;
      }
    }
  }
}
hr {
  margin: 32px 0 50px 0;
  border-top: none;
}
</style>
<style lang="scss">
.c reate-plan {
  label,
  .ant-form-item-label > label {
    font-weight: var(--normal);
    color: var(--main-black);
    text-align: left;
    font-size: var(--base);
  }
}
</style>
